clear all;close all
x=[-1:.2:1];
y=x;

[X,Y]=meshgrid(x,y);
Z=.2*(1 - X.^2 + Y.^2);

figure(1)
subplot(3,1,1)
surface(X,Y,0.*X)
view([-45,60])
axis([-1.5 1.5 -1.5 1.5 0 1])
xlabel('X Coordinate')
ylabel('Y Coordinate')
zlabel('Z Coordinate')
title('Initial system \{\xi^1,\xi^2\} ')

subplot(3,1,2)
tmpx=2*X.*(.1*sin(Y.*X-.5)+.5);
tmpy=6*Y.*(.1*sin(X.*Y-.5)+.2);
surface(tmpx,tmpy,0.*X);
view([-45,60])
axis([-1.5 1.5 -1.5 1.5 0 1])
xlabel('X Coordinate')
ylabel('Y Coordinate')
zlabel('Z Coordinate')
title('Intermediate system - \{s^1,s^2\}')

subplot(3,1,3)
surface(tmpx,tmpy,Z);
view([-45,60])
axis([-1.5 1.5 -1.5 1.5 0 1])
xlabel('X Coordinate')
ylabel('Y Coordinate')
zlabel('Z Coordinate')
title('Final coordinate system - \{x^1,x^2,x^3\}')
orient tall

print -depsc2 ./Fig/Example.ps
