program Topoblend2D
  use sep
  implicit none  
  integer                             :: ix,iz,ns,nz,nx,nnx
  real                                :: depth,ox,dx
  complex, dimension(:  ),allocatable :: pin
  real   , dimension(:,:),allocatable :: x,z
  complex, dimension(:,:),allocatable :: s
  real, allocatable :: xline(:),zline(:)

  call sep_init()
  call from_history("n1",nx)
  call from_history("d1",dx)
  call from_history("o1",ox)
  call from_param("depth",depth,8000.) !! Depth extension of grid
  call from_param("nz",nz,100       )
  call from_param("ns",ns,50        ) !! # of side pad points
  
  nnx=nx+2*ns
write(0,*) nnx
  allocate( pin(nx), x(nz,nnx), z(nz,nnx) )
  allocate( s(nz,nnx),xline(nnx),zline(nz) )

  call sep_read ( pin )
  
  zline = (/ (iz, iz=0,nz-1  ) /) / real(nz-1 )
  
  x(1,       1:ns) = (/ (ix,ix=-ns,-1) /) * dx + real(pin(1)) 
  x(1, ns+1:ns+nx) = real(pin)
  x(1,nx+ns+1:nnx) = (/ (ix,ix=1,ns)   /) * dx + real(pin(nx)) 
  x(1:nz,       1) = x(1,1)
  x(1:nz,     nnx) = x(1,nnx)
  x(nz,     1:nnx) = x(1,1:nnx)

  z(1,1:ns       ) = aimag(pin(1))
  z(1, ns+1:ns+nx) = aimag(pin)
  z(1,ns+nx+1:nnx) = aimag(pin(nx))
  z(nz,     1:nnx) = depth
  z(1:nz,       1) = z(nz,  1)*zline+z(1,  1)*(1-zline)
  z(1:nz,     nnx) = z(nz,nnx)*zline+z(1,nnx)*(1-zline)

  do ix=2,nnx-1
     z(:,ix) = z(nz,ix) * zline + z(1,ix) * (1-zline)
     x(:,ix) = x(nz,ix) * zline + x(1,ix) * (1-zline)
  end do
  
  s=cmplx(x,z)
  
  call to_history("n1",nz)
  call to_history("n2",nnx)
  call to_history("o1",z(1,1) )
  call to_history("o2",x(1,1) )
  call to_history("d2",dx )
  call to_history("d1",(depth - z(1,1))/real(nz-1) )
  call to_history("esize",8 )
  call hclose()
  call sep_write(s)
  
  deallocate( pin,x,z,s,xline,zline )
  
  call exit()
end program Topoblend2D
